#!/bin/bash
svn up
CWD=`pwd`
TMPDIR=`mktemp -d`
trap "rm -rf $TMPDIR" EXIT
REV=$(svn info | awk '/^Revision:/{print $2}')
svn export . $TMPDIR/thesis
cd $TMPDIR/thesis
make clean
mkdir ../thesis-latin1
find . -not -path '*latin1*' -type d -exec mkdir ../thesis-latin1/{} \;
find . -not -path '*latin1*' -type f -exec cp '{}' '../thesis-latin1/{}' \;
find . \( -name \*.tex -or -name \*.cls -or -name \*.sty -or -name \*.bib \) -not -path '*latin1*' -exec iconv -f utf-8 -t iso-8859-1 "{}" -o ../thesis-latin1/"{}" \;
sed -i 's/utf8 % or latin1/latin1 % or utf8/g' ../thesis-latin1/thesis.tex
cd $TMPDIR
zip -r thesis-r$REV-utf8.zip thesis/
zip -r thesis-r$REV-latin1.zip thesis-latin1/
cp thesis-*.zip $CWD
