% tum class
%
% Diese Klasse soll fuer Diplom und andere Arbeiten am Lehrstuhl verwendet werden. Dabei ist diese Klasse dafuer
% ausgelegt moeglichst wenige/keine Aenderungen erforderlich zu machen fuer englische und deutsche Arbeiten.
% 
% Im grossen sollte die Vorlage den Richtlinien des Corporate Design der TUM entsprechen. Aenderungen und 
% Aktualisierungen bitte zurueck an die Autoren. 
%
%
% Copyright (c) 2009-2013 Forschungsgruppe Verteilte Multimodale Informationsverarbeitung (TU-EI-VMI)
% 
% 
% Beteiligt:
% * Luis Roalter <roalter@tum.de>
% * Stefan Diewald <stefan.diewald@tum.de>
% * Matthias Kranz <matthias.kranz@tum.de>
%

%
%
% STOP!
%
% Keine Aenderungen ab hier!
% 
% No modifications below here!
%


\ProvidesClass{tum}

\RequirePackage{ifthen}
\LoadClass[a4paper,
	11pt,
	BCOR5mm,
	DIV12,
	oneside,
	chapterprefix,
        numbers=enddot,
        cleardoublepage=plain,
        openright,
        bibliography=totoc,
        bibliography=numbered,
        index=totoc,
        listof=totoc,
        listof=numbered]{scrreprt}

\sloppy

\newcommand\lang{en}\newcommand\setlang[1]{\renewcommand\lang{#1}}
\newcommand\smallchapter{unset}\newcommand\setsmallchapter[1]{\renewcommand\smallchapter{#1}}
\newcommand\myencoding{utf8}\newcommand\setencoding[1]{\renewcommand\myencoding{#1}}	
\newcommand\myinstitute{VMI}\newcommand\setinstitute[1]{\renewcommand\myinstitute{#1}}
\newcommand\GetBibStyle{ieeetr-en}\newcommand\setBibStyle[1]{\renewcommand\GetBibStyle{#1}}
\newcommand\myonesided{set}\newcommand\setonesided[1]{\renewcommand\myonesided{#1}}
\DeclareOption{oneside}{\setonesided{set}}
\DeclareOption{en}{\KOMAoptions{numbers=enddot}\setBibStyle{ieeetr-en}\setlang{en}}
\DeclareOption{de}{\KOMAoptions{numbers=noenddot}\setBibStyle{ieeetr-de}\setlang{de}}
\DeclareOption{twoside}{\KOMAoptions{twoside}\setonesided{unset}}
\DeclareOption{noenddot}{\KOMAoptions{numbers=noenddot}}
\DeclareOption{enddot}{\KOMAoptions{numbers=enddot}}
\DeclareOption{smallchapter}{\setsmallchapter{set}}
\DeclareOption{nosmallchapter}{\setsmallchapter{unset}}
\DeclareOption{utf8}{\setencoding{utf8}}%
\DeclareOption{latin1}{\setencoding{latin1}}%
\DeclareOption{vmi}{\setinstitute{VMI}}%
\DeclareOption{lkn}{\setinstitute{LKN}}%
\DeclareOption{lmt}{\setinstitute{LMT}}%
\DeclareOption{wum}{\setinstitute{WUM}}%
\DeclareOption{11pt}{\KOMAoptions{11pt}}%
\DeclareOption*{%
      \PassOptionsToClass{\CurrentOption}{scrreprt}%
}
\ProcessOptions


% Main defines
\newcommand\SelectIfTrue[3]{\ifthenelse{\equal{#1}{set}}{#2}{#3}}%
\newcommand\SelectByEncoding[2]{\ifthenelse{\equal{\myencoding}{utf8}}{#1}{#2}}%
\newcommand\SelectIfInstitute[2]{\ifthenelse{\equal{\myinstitute}{#1}}{#2}{}}%
\newcommand\SelectByLanguage[2]{\ifthenelse{\equal{\lang}{de}}{#2}{#1}}%
\newcommand\SelectByReport[2]{\ifthenelse{\equal{\MyType}{R}}{#1}{#2}}%
\newcommand\RestoreLanguage{\switchlanguage{\lang}}%
\newcommand\SelectIfPartner[2]{\ifthenelse{\equal{\insertIPName}{none}}{#2}{#1}}%
\newcommand\SelectIfOnesided[2]{\ifthenelse{\equal{\myonesided}{set}}{#1}{#2}}%
%
% Includes
% 
%------------------------------------------------------------------------
\usepackage[american,ngerman]{babel}
% Use list of tabels, etc. in table of contents:
\usepackage{tocbibind}
% German paragraph skip
\usepackage{parskip}
% Use A4-paper efficiently:
\usepackage{a4wide}
% Index-generation
\usepackage{makeidx}
% Einbinden von URLs:
\usepackage[hyphens]{url}
% Include .eps-files (needed also for the TUM-logo):
%\usepackage{epsf}
% Special \LaTex symbols (e.g. \BibTeX):
\usepackage{doc}
% Include Graphic-files:
%\usepackage{graphics}
% Include doc++ generated tex-files:
%\usepackage{docxx}

% Acronym handling (Introduction of acronyms, list of acronyms, etc.)
\usepackage{acronym} % or for printing only used: \usepackage[printonlyused]{acronym}

%------------------------------------------------------------------------
\SelectByEncoding{\usepackage[utf8]{inputenc}}{\usepackage[latin1]{inputenc}}
\usepackage[T1]{fontenc}
\usepackage{lmodern}
%pdfsync destroys tabularx X columns as well as tabular fixed size colums, such as p{}, etc.
%\usepackage{pdfsync}
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{textcomp}
\usepackage[binary, squaren]{SIunits}
%das Einbinden von Bildern und Tabellen
%\usepackage{here}
\usepackage{psfrag}
%die Bibliography
\usepackage[sort&compress,numbers,square]{natbib}
% not available on windows
\usepackage{hypernat}
\usepackage{ifpdf}
%Verwendung von Farben
\usepackage{xcolor}
% Colored table rows and cells
\usepackage{colortbl}
%den Stil der Kapitel
\usepackage{titlesec}
\usepackage[automark,standardstyle,markusedcase]{scrpage2}
\setheadsepline[\textwidth]{0.2pt}
%\setfootsepline[\textwidth]{0.2pt}
\ihead{\headmark} \ohead{\pagemark} \cfoot{} 

%\makeatletter
\renewcommand\@makefntext[1]{\leftskip=2em\hskip-1em\@makefnmark#1}
%\makeatother

\pagestyle{scrheadings}

\SelectIfTrue{\smallchapter}{\SelectByLanguage{\titleformat{\chapter}[hang]{\huge\bf}{{\huge{\thechapter.\ }}}{0em}{}}
{\titleformat{\chapter}[hang]{\huge\bf}{{\huge{\thechapter\ \,}}}{0em}{}}}{}
%----------------------------------------------------------------------------------------------------------------------------------------------
\pagestyle{empty}
\pagenumbering{roman}
\definecolor{linkblue}{rgb}{0,0.1,0.6}
\definecolor{citegreen}{rgb}{0,0.25,0.15}%{0.1,0.5,0.4}%{0.125,0.6,0.5}
\definecolor{linkred}{rgb}{0.8,0,0.005}%{0.6,0,0.1}
\definecolor{mailviolet}{rgb}{0.3,0,0.35}%{0.6,0,0.1}
\definecolor{tumblue}{rgb}{0,0.396,0.741}
\ifpdf %pdflatex
    \usepackage[pdftex]{graphicx}
    \pdfcompresslevel=0
    \DeclareGraphicsExtensions{.jpg,.pdf,.png,.eps,.ps}%.mps}
\else %latex && dvips
    \usepackage[dvips]{graphicx}
    \DeclareGraphicsExtensions{.eps,.ps,.png,.pdf,.jpg}%.bmp,.tif,.tiff,.tga}
\fi
%das drehen
\usepackage{rotating}
%Zeilenabstaende regulieren mit \singlespacing, \onehalfspacing, \doublespacing
\usepackage{setspace}
%Schriftart Sans Serif
\renewcommand*\familydefault{\sfdefault} 
\usepackage{graphicx}
% SOME SETTINGS:

\ifpdf %pdflatex
%    \usepackage[hyperindex,pdftex,colorlinks=false]{hyperref}
%    \usepackage[hyperindex,pdfmark,pdftex,colorlinks=true,linkcolor=linkblue,citecolor=citegreen,urlcolor=linkred,filecolor=linkred]{hyperref}
    \usepackage[hyperindex,pdftex,colorlinks=true,linkcolor=tumblue,citecolor=citegreen,urlcolor=mailviolet,filecolor=linkred]{hyperref}
\else %latex && dvips
    \usepackage[hyperindex,pdfmark,dvips,colorlinks=true,linkcolor=tumblue,citecolor=citegreen,urlcolor=mailviolet,filecolor=linkred]{hyperref}
\fi

% Allows switching languages within the document
\newcommand\switchlanguage[1]{%
	\ifthenelse{\equal{#1}{de}} {\selectlanguage{ngerman}} {\selectlanguage{american}}%
	\nonfrenchspacing%
}%
\newcommand\MyType{M}%
\newcommand\DefineType[1]{ \renewcommand\MyType{#1}\newcommand\insertType{\ifthenelse{\equal{\lang}{de}}%
	{\ifthenelse{\equal{#1}{Master}}{Master-Arbeit}%
	{\ifthenelse{\equal{#1}{Bachelor}}{Bachelor-Arbeit}%
	{\ifthenelse{\equal{#1}{Diplom}}{Diplomarbeit}%
	{\ifthenelse{\equal{#1}{Studien}}{Studienarbeit}%
	{\ifthenelse{\equal{#1}{IDP}}{IDP}%
	{\ifthenelse{\equal{#1}{Report}}{Bericht}%
	{\ifthenelse{\equal{#1}{Semester}}{Semesterarbeit}%
	{\ifthenelse{\equal{#1}{ExpSemester}}{Experimentelle Semesterarbeit}%
	{\ifthenelse{\equal{#1}{TheSemester}}{Theoretische Semesterarbeit}%
	{\ifthenelse{\equal{#1}{KonSemester}}{Konstruktive Semesterarbeit}%
	{\ifthenelse{\equal{#1}{ExpDiplom}}{Experimentelle Diplomarbeit}%
	{\ifthenelse{\equal{#1}{TheDiplom}}{Theoretische Diplomarbeit}%
	{\ifthenelse{\equal{#1}{KonDiplom}}{Konstruktive Diplomarbeit}%
	{\ifthenelse{\equal{#1}{PhD}}{Dissertation}%
	{#1}%
	}}}}}}}}}}}}}}%
	% engl.
	{\ifthenelse{\equal{#1}{Master}}{Master Thesis}%
	{\ifthenelse{\equal{#1}{Bachelor}}{Bachelor Thesis}%
	{\ifthenelse{\equal{#1}{Diplom}}{Diploma Thesis}%
	{\ifthenelse{\equal{#1}{Studien}}{Studien Thesis}%
	{\ifthenelse{\equal{#1}{IDP}}{IDP}%
	{\ifthenelse{\equal{#1}{Report}}{Report}%
	{\ifthenelse{\equal{#1}{Semester}}{Semester Thesis}%
	{\ifthenelse{\equal{#1}{ExpSemester}}{Experimental Semester Thesis}%
	{\ifthenelse{\equal{#1}{TheSemester}}{Theoretical Semester Thesis}%
	{\ifthenelse{\equal{#1}{KonSemester}}{Constructive Semester Thesis}%
	{\ifthenelse{\equal{#1}{ExpDiplom}}{Experimental Diploma Thesis}%
	{\ifthenelse{\equal{#1}{TheDiplom}}{Theoretical Diploma Thesis}%
	{\ifthenelse{\equal{#1}{KonDiplom}}{Constructive Diploma Thesis}%
	{\ifthenelse{\equal{#1}{PhD}}{Dissertation}%
	{#1}%
	}}}}}}}}}}}}}}}%
}%

\newcommand\additionalauthor{\\&}
\newcommand\DefineAuthor[1]{ \newcommand\insertAuthor{#1} \newcommand\insertTableAuthor{#1}}%
\newcommand\DefineAuthors[2]{ \newcommand\insertAuthors{#1\\#2} \newcommand\insertTableAuthors{#1\additionalauthor#2} }%
\newcommand\DefineTitle[2]{ \newcommand\insertTitle{#1\\[1.0ex]#2}\newcommand\insertFirstTitle{#1}\newcommand\insertSecondTitle{#2}}%
\newcommand\DefineVorsitzender[1]{ \newcommand\insertVorsitzender{#1}}%
\newcommand\DefinePhDProfessor[2]{ \newcommand\insertProfessorFirst{#1}\newcommand\insertProfessorSecond{#2}}%
\newcommand\DefineAckDatum[1]{\newcommand\insertDateBegin{#1}}%
\newcommand\DefineStreet[1]{ \newcommand\insertStreet{#1} }%
\newcommand\DefineTown[1]{ \newcommand\insertTown{#1} }%
\newcommand\DefineAdvisor[1]{ \newcommand\insertAdvisor{#1} }%
\newcommand\DefineAdvisors[2]{ \newcommand\insertAdvisor{#1 \\
&   #2}}
\newcommand\DefineBeginDate[1]{ \newcommand\insertDateBegin{#1} }%
\newcommand\DefineEndDate[1]{ \newcommand\insertDateEnd{#1} }%
\newcommand\DefineSemester[1]{ \newcommand\insertSemester{#1} }%
\newcommand\DefineGroup[1]{ \newcommand\insertGroup{#1} }%
\newcommand\DefineMatrikelNr[1]{ \newcommand\insertMatrikelNr{#1} }%

\newcommand\insertUniLogo{logos/TUMLogo_oZ_Outline_blau_RGB}
\newcommand\insertUniversity{Technische Universit\"at M\"unchen}
\newcommand\insertUniAddress{Arcisstra\ss e 21}
\newcommand\insertFullAddress{\insertInstitute\\\insertFaculty\\\insertUniversity\\\insertUniAddress\\\insertUniTown}
\newcommand\DefineProfessor[1]{ \renewcommand\insertProfessor{#1} }
\newcommand\DefineUniversity[1]{ \renewcommand\insertUniversity{#1} }
\newcommand\DefineInstitute[1]{ \renewcommand\insertInstitute{#1} }
\newcommand\DefineFaculty[1]{ \renewcommand\insertFaculty{#1} }

\newcommand\insertIPName{none}
\newcommand\DefineIPAdvistor[1]{ \newcommand\insertIPAdvisor{#1} }
\newcommand\DefineIPName[1]{ \renewcommand\insertIPName{#1} }
\newcommand\DefineIPStreet[1]{ \newcommand\insertIPStreet{#1} }
\newcommand\DefineIPTown[1]{ \newcommand\insertIPTown{#1} }
\newcommand\DefineIPLogo[1]{ \newcommand\insertIPLogo{#1} }
\newcommand\insertFullIPAddress{\insertIPName\\\insertIPStreet\\\insertIPTown}

% Internationalization ;)
\SelectByLanguage{%
	\newcommand\insertUniTown{80333 Munich}%
	\newcommand\insertUniSmallTown{Munich}%
	\newcommand\intlAuthor{Author}%
	\newcommand\intlDateEnd{End}%
	\newcommand\intlDateStart{Begin}%
	\newcommand\intlAdvisor{Advisor}%
	\newcommand\intlLocation{Address}%
	\newcommand\intlNumber{Matriculation Number}%
	\newcommand\intlGroup{Group}%
	\newcommand\intlSemester{Term}%
	\newcommand\intlOrgans{Collaborating Partners}%
	\newcommand\intlStatement{Declaration}%
}%
{%
	\newcommand\insertUniTown{80333 M\"unchen}%
	\newcommand\insertUniSmallTown{M\"unchen}%
	\newcommand\intlAuthor{Verfasser}%
	\newcommand\intlDateEnd{Abgabe}%
	\newcommand\intlDateStart{Beginn}%
	\newcommand\intlAdvisor{Betreuer}%
	\newcommand\intlLocation{Anschrift}%
	\newcommand\intlNumber{Matrikelnummer}%
	\newcommand\intlGroup{Gruppe}%
	\newcommand\intlSemester{Semester}%
	\newcommand\intlOrgans{Beteiligte Organisationen}%
	\newcommand\intlStatement{Erkl\"arung}%
}%


\newcommand\intlProfessor{Professor}%

\SelectIfInstitute{VMI} {%
	\newcommand\insertProfessor{Prof.~Dr.-Ing.~Eckehard~Steinbach}%
	\newcommand\insertInstituteLogo{logos/FG_VMI_RGB}%
	\newcommand\insertFacultyLogo{logos/EI_blau_RGB}%
	\SelectByLanguage{%
		\newcommand\insertInstitute{Institute for Media Technology\\[0.5ex]Distributed Multimodal Information Processing Group}%
		\newcommand\insertFaculty{Department of Electrical Engineering and Information Technology}%
	}{%
		\newcommand\insertInstitute{Lehrstuhl f\"ur Medientechnik\\[0.5ex]Forschungsgruppe Verteilte Multimodale Informationsverarbeitung}
		\newcommand\insertFaculty{Fakult\"at f\"ur Elektrotechnik und Informationstechnik}
}}%

\SelectIfInstitute{LMT} {%
	\newcommand\insertProfessor{Univ.-Prof.~Dr.-Ing.~Eckehard~Steinbach}%
	\newcommand\insertInstituteLogo{logos/LS_LMT_RGB}%
	\newcommand\insertFacultyLogo{logos/EI_blau_RGB}%
	\SelectByLanguage{%
		\newcommand\insertInstitute{Institute for Media Technology}%
		\newcommand\insertFaculty{Department of Electrical Engineering and Information Technology}%
	}{%
		\newcommand\insertInstitute{Lehrstuhl f\"ur Medientechnik}%
		\newcommand\insertFaculty{Fakult\"at f\"ur Elektrotechnik und Informationstechnik}%
}}%

\SelectIfInstitute{LKN} {%
	\newcommand\insertProfessor{Univ.-Prof.~Dr.-Ing.~Wolfgang~Kellerer}%
	\newcommand\insertInstituteLogo{logos/LS_LKN_RGB}%
	\newcommand\insertFacultyLogo{logos/EI_blau_RGB}%
	\SelectByLanguage{%
		\newcommand\insertInstitute{Institute for Communication Networks}%
		\newcommand\insertFaculty{Department of Electrical Engineering and Information Technology}%
	}{%
		\newcommand\insertInstitute{Lehrstuhl f\"ur Kommunikationsnetze}%
		\newcommand\insertFaculty{Fakult\"at f\"ur Elektrotechnik und Informationstechnik}%
}}%
	
\SelectIfInstitute{WKM} {%
	\newcommand\insertProfessor{Prof.~Dr.~mont.~habil.~Dr.~h.~c.~Ewald~Werner}%
	\newcommand\insertInstituteLogo{logos/LS_WUM_OS_RGB}%
	\newcommand\insertFacultyLogo{logos/MW_blau_RGB}%
	\SelectByLanguage{%
		\newcommand\insertInstitute{Institute of Materials Science and Mechanics of Material}%
		\newcommand\insertFaculty{Faculty of Mechanical Engineering}%
	}{%
		\newcommand\insertInstitute{Lehrstuhl f\"ur Werkstoffkunde und Werkstoffmechanik}%
		\newcommand\insertFaculty{Fakult\"at f\"ur Maschinenwesen}%
}}%
	

\newcommand\GenerateHead{\ \\[-1cm]
\includegraphics{\insertFacultyLogo}
\rule{5mm}{0pt}
\raisebox{-0.2mm}{\includegraphics{\insertInstituteLogo}}
\hfill
\includegraphics{\insertUniLogo}
\\[1cm]
{\large \insertFaculty \\[0.5ex]
\insertInstitute \\[0.5ex]
\insertProfessor \\[0.5ex]
}
\par\ }
\newcommand\GeneratePhDHead{\ \\[-1cm]
\includegraphics{\insertFacultyLogo}
%\rule{5mm}{0pt}
%\raisebox{-0.2mm}{\includegraphics{\insertInstituteLogo}}
\hfill
\includegraphics{\insertUniLogo}
\\[0.2cm]
{\centering
\large \insertUniversity \\[0.5ex]
\insertFaculty \\[0.5ex]
\insertInstitute \\[0.5ex]
}
\par\ }
